<?php
/******************************************************
  MyBB Wrapper for full integration of CPG within MyBB
  ******************************************************
  Copyright (c) 2010 PavemenSucks.com
  v1.0 

  http://www.pavementsucks.com/board/misc.php?page=plugins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.

********************************************************/


if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
if (!defined('CORE_PLUGIN')) 
{
    define('CORE_PLUGIN', true);
}


// Add an install action
$thisplugin->add_action('plugin_install','mybb_wrapper_install');

// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','mybb_wrapper_uninstall');

// Add a configure action
$thisplugin->add_action('plugin_configure','mybb_wrapper_configure');

// Add a filter for the wrapper
$thisplugin->add_filter('template_html','mybb_wrapper_apply');

//Apply the wrapper as custom_header and custom_footer
function mybb_wrapper_apply($html)
{
        global $CONFIG;
        
        include_once('cpg_mybb_wrapper.php');
        $html = str_replace('{CUSTOM_HEADER}', $cpg_main_top, $html);
        $html = str_replace('{CUSTOM_FOOTER}', $cpg_main_bottom, $html);
        return $html;
}

//configure function
function mybb_wrapper_configure() 
{
        global $CONFIG, $lang_common, $lang_pluginmgr_php, $lang_admin_php, $icon_array,$default_path_to_mybb;
        $superCage = Inspekt::makeSuperCage();
        if (!defined('ADMIN_PHP')) {
            defined('ADMIN_PHP');
        }
        $action = $superCage->server->getEscaped('REQUEST_URI');
        
        $icon_array['ok']  = cpg_fetch_icon('ok', 2);
        $icon_array['config']  = cpg_fetch_icon('config', 2);

        if (isset($CONFIG['mod_updates_pathtomybbroot']) != TRUE) 
        {
            $CONFIG['mod_updates_pathtomybbroot'] = '/home/username/public_html/mybb/';
        }
        if (isset($CONFIG['mod_updates_path_to_wrapper']) != TRUE) 
        {
            $CONFIG['mod_updates_path_to_wrapper'] = '../gallery/cpg_mybb_wrapper.php';
        }
       list($timestamp, $form_token) = getFormToken();

        echo <<< EOT
    <form action="{$action}" method="post" name="mybb_wrapper_configure">
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
            <tr>
                <td class="tableb" width="50%">
                    MyBB Root Path (with trailing slash):
                </td>
                <td class="tableb" width="50%">
                    <input size="50" type="text" name="pathtomybbroot" value="{$CONFIG['mod_updates_pathtomybbroot']}" class="textinput" />
                </td>
            </tr>
             <tr>
                <td class="tableb" width="50%">
                    Wrapper File (path relative to MyBB install):
                </td>
                <td class="tableb" width="50%">
                    <input size="50" type="text" name="path_to_wrapper" value="{$CONFIG['mod_updates_path_to_wrapper']}" class="textinput" />
                </td>
            </tr>
           <tr>
                <td class="tablef">
                </td>
                <td class="tablef">
                    <button type="submit" class="button" name="submit" value="{$lang_common['go']}">{$icon_array['ok']}{$lang_common['go']}</button>
                    <input type="hidden" name="form_token" value="{$form_token}" />
                    <input type="hidden" name="timestamp" value="{$timestamp}" />
                </td>
            </tr>
        </table>
    </form>
EOT;
}

// Install function
function mybb_wrapper_install() 
{
        global $CONFIG, $thisplugin;
        $superCage = Inspekt::makeSuperCage();

        if ($superCage->post->keyExists('pathtomybbroot')) 
        {
                require 'include/sql_parse.php';
               
                $pathtomybbroot = $superCage->post->getEscaped('pathtomybbroot');
            
                $sql_query = "INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('mod_updates_pathtomybbroot', '{$pathtomybbroot}')";

                cpg_db_query($sql_query);

                $path_to_wrapper = $superCage->post->getEscaped('path_to_wrapper');
            
                $sql_query = "INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('mod_updates_path_to_wrapper', '{$path_to_wrapper}')";

                cpg_db_query($sql_query);

                return true;
        } 
        else
        {
                return 1;
        }
}

// Uninstall
function mybb_wrapper_uninstall() {
        global $CONFIG;

        cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'mod_updates_pathtomybbroot'");

        return true;
}

?>